#include"ValueField.h"
#include<string.h>
#include<stdlib.h>
#include<stdio.h>

void
ValueField::init(GtkBox *parentmenu,const char *labeltext)
{
    labeltext_=labeltext;
    hbox_ = gtk_hbox_new(FALSE, 0);
    label_ = gtk_label_new(labeltext_);
    entry_ = gtk_entry_new();
    gtk_box_pack_start(GTK_BOX(hbox_), label_, TRUE, TRUE, 0);
    gtk_box_pack_start(GTK_BOX(hbox_), entry_, TRUE, TRUE, 0);
    gtk_entry_set_max_length (GTK_ENTRY (entry_), 50);
    gpointer vfobj = (gpointer)this;
    g_signal_connect(G_OBJECT(entry_), "activate",
		     G_CALLBACK(entrycallback),
		     vfobj);

    gtk_box_pack_start(GTK_BOX(parentmenu), hbox_, TRUE, TRUE, 0);
}


void ValueField::notify()
{
    if(listener_)
    {
	listener_->redraw();
    }
}

void ValueField::entrycallback(GtkWidget *widget,gpointer func_data)
{

    ValueField *vf=(ValueField *)func_data;
    const gchar *entry_text = gtk_entry_get_text(GTK_ENTRY(vf->entry_));
    printf("Valuefield %s: contents: %s\n",vf->labeltext_,entry_text);
    vf->callback(entry_text);
}

/*----------------------------------*/
void DoubleValueField::init(GtkBox *parentmenu,const char *labeltext,double initial)
{
    ValueField::init(parentmenu,labeltext);
    set(initial);
}

void DoubleValueField::set(double w)
{
    char str[16];
    snprintf(str,16,"%f",w);
    gtk_entry_set_text(GTK_ENTRY(entry_),str);
    value_=w;
}

void DoubleValueField::callback(const gchar *entry_text)
{
    double nv;
    char *p=0;
    nv=strtod(entry_text,&p);
    if(*p=='\0')
    {
	set(nv);
	notify();
    }
    else
    {
	set(value_);
    }
}

/*----------------------------------------*/
void IntValueField::init(GtkBox *parentmenu,const char *labeltext,int initial)
{
    ValueField::init(parentmenu,labeltext);
    set(initial);
}

void IntValueField::set(int w)
{
    char str[16];
    snprintf(str,16,"%d",w);
    gtk_entry_set_text(GTK_ENTRY(entry_),str);
    value_=w;
}

void IntValueField::callback(const gchar *entry_text)
{
    int nv;
    char *p=0;
    nv=(int)strtol(entry_text,&p,10);
    if(*p=='\0')
    {
	set(nv);
	notify();
    }
    else
    {
	set(value_);
    }
}
