#ifndef VALUEFIELD_H
#define VALUEFIELD_H
#include<gtk/gtk.h>

class RedrawEventListener
{
public:
    virtual void redraw()=0;
};

class ValueField 
{
public:
    ValueField():hbox_(0),label_(0),labeltext_(0),entry_(0),
	         listener_(0) {}
    void init(GtkBox *parentmenu,const char *labeltext);
    void addRedrawEventListener(RedrawEventListener *listener)
	{
	    listener_=listener;
	}
    static void entrycallback(GtkWidget *widget,gpointer func_data);
private:
    GtkWidget *hbox_;
    GtkWidget *label_;
    const char *labeltext_;

protected:
    void notify();
    virtual void callback(const gchar *entry_text)=0;
    GtkWidget *entry_;
    RedrawEventListener *listener_;
    
};

//* type specific sub-Classes
//??? templates sind gute idee, string convertierung mit strtoT und sprintf
// verhindern das - strsteam ?
class DoubleValueField : public ValueField
{
public:
    DoubleValueField():ValueField(),value_(0.0) {}
    void init(GtkBox *parentmenu,const char *labeltext,double initial);
    double get() { return value_; }
    void set(double w);
protected:
    virtual void callback(const gchar *entry_text);
private:
    double value_; 
};

class IntValueField : public ValueField
{
public:
    IntValueField():ValueField(),value_(0) {}
    void init(GtkBox *parentmenu,const char *labeltext,int initial);
    int get() { return value_; }
    void set(int w);
protected:
    virtual void callback(const gchar *entry_text);
private:
    int value_; 
};

#endif
